<template>
  <div>
    <form @submit.prevent="signIn">
      <div class="md-card-content">
        <div class="text-danger">
          <p>{{ errorMessage }}</p>
        </div>
        <div class="md-form-group indent-message">
          <label>{{ $t('email') }}</label>
          <input
            id="email"
            v-model="v$.form.email.$model"
            data-vv-name="email"
            type="email"
            required
          />
          <div
            v-for="(error, index) of v$.form.email.$errors"
            :key="index"
            class="text-danger"
          >
            <p>{{ error.$message }}</p>
          </div>
        </div>
        <div class="md-form-group">
          <label>{{ $t('password') }}</label>
          <input
            id="password"
            v-model="v$.form.password.$model"
            data-vv-name="password"
            type="password"
            required
          />
          <div
            v-for="(error, index) of v$.form.password.$errors"
            :key="index"
            class="text-danger"
          >
            <p>{{ error.$message }}</p>
          </div>
        </div>
      </div>
      <div class="md-card-actions md-alignment-right">
        <button
          type="submit"
          :disabled="isSubmitButtonDisabled"
          class="md-button md-info"
        >
          <div id="singIn" class="md-ripple">
            <div class="md-button-content">
              {{ $t('sign_in') }}
            </div>
          </div>
        </button>
      </div>
    </form>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';

import useVuelidate from '@vuelidate/core';
// import { required, email, minLength } from '@vuelidate/validators';
import { required, email, maxLength } from '../../utils/i18n-validators';

export default {
  setup() {
    return { v$: useVuelidate() };
  },
  data() {
    return {
      form: {
        email: '',
        password: '',
      },
      errorMessage: null,
      mfaCode: '',
      isSubmitButtonDisabled: false,
      nextTo: 'init',
    };
  },
  validations() {
    return {
      form: {
        email: {
          required,
          email,
          max: maxLength(255),
        },
        password: {
          required,
          max: maxLength(255),
        },
      },
    };
  },
  created() {
    this.$i18n.locale = 'en';
    this.removeHash();
  },
  computed: {
    ...mapGetters(['prevPath', 'userState']),
  },
  methods: {
    ...mapActions(['setUserState', 'postSession', 'storeCurrentPath']),

    async submitForm() {
      const isFormCorrect = await this.v$.$validate();
      // you can show some extra alert to the user or just leave the each field to show it's `$errors`.
      if (!isFormCorrect) return;
      // actually submit form
    },

    // URLの accounts/#/sign_in を accounts/sign_in に強制的に変更する
    removeHash() {
      if (this.$router.currentRoute.hash) {
        this.$router.replace('/accounts/sign_in');
      }
    },

    signIn: async function (e) {
      this.errorMessage = null;
      if (this.v$.$invalid) {
        console.log('valid error');
        this.errorMessage = this.$t('mail_address_is_incorrect');
        return;
      }

      this.isSubmitButtonDisabled = true;

      const params = {
        email: this.form.email,
        password: this.form.password,
        mfa_code: this.form.mfaCode,
      };

      this.postSession(params)
        .then((e) => {
          if (this.prevPath) {
            // 前のredirect pathが存在する場合戻る
            const nextPath = this.prevPath;
            this.storeCurrentPath(null);
            this.$router.push(nextPath);
            return;
          }
          this.$router.push({ path: '/accounts/terms' });
        })
        .catch((e) => {
          console.log('[debug][postSession] e = ', e);
          if (!e.response) {
            this.$notify({
              title: this.$t('network_error'),
              type: 'danger',
            });
          } else {
            if (e.response.status == 428) {
              this.nextTo = 'mfa';
              return;
            }

            this.errorMessage = e.response.data.message;
            // パスワードをクリアする
            if (this.nextTo == 'init') {
              this.password = '';
            }
          }
        })
        .finally(() => {
          this.isSubmitButtonDisabled = false;
        });
    },
  },
};
</script>
